/***************************************************************************
 *   Copyright (C) 2004 by dsievers@NIVIDA                                 
 *                                                               
 ***************************************************************************/
#ifndef VWRVIEW_H
#define VWRVIEW_H

#include <wx/docview.h>

#include "nvsg/nvsgapi.h"
#include "GLwxRAWnd.h"
#include "nvui/TrackballCamManip.h"


/**
@author dsievers,,,
*/
class VwrView : public wxView
{
DECLARE_DYNAMIC_CLASS(VwrView)

public:
    VwrView();
    ~VwrView();
        
    //virtual bool OnCreate(wxDocument *doc, long flags);
    virtual void OnDraw(wxDC *dc);
    virtual void OnUpdate(wxView *sender, wxObject *hint = (wxObject *) NULL); 
    virtual bool OnClose(bool deleteWindow = TRUE);

    void cleanup();

    void viewAll();
    void setViewMode(GLwxRAWnd::ViewMode mode) {  if(m_pRA) m_pRA->setViewMode(mode); }      
   
    bool init();
protected:
    void cleanupRenderArea();        
    void setupRenderArea();
    
    GLwxRAWnd               * m_pRA;        
    const nvsg::Camera      * m_pCamera;
    nvui::CameraManipulator * m_pCamManip;
};

#endif
